Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/ZhuEncodedSolution.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/ZhuEncodedSolution.cs	(revision 17698)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/ZhuEncodedSolution.cs	(revision 17698)
@@ -0,0 +1,139 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.Zhu {
+  [Item("ZhuEncodedSolution", "Represents a Zhu encoded solution of the VRP. It is implemented as described in Zhu, K.Q. (2000). A New Genetic Algorithm For VRPTW. Proceedings of the International Conference on Artificial Intelligence.")]
+  [StorableType("1A5F5A1D-E4F5-4477-887E-45FC488BC459")]
+  public class ZhuEncodedSolution : General.PermutationEncoding {
+    #region IVRPEncoding Members
+    public override int GetTourIndex(Tour tour) {
+      return 0;
+    }
+
+    public override List<Tour> GetTours() {
+      List<Tour> result = new List<Tour>();
+
+      Tour newTour = new Tour();
+
+      for (int i = 0; i < this.Length; i++) {
+        int city = this[i] + 1;
+        newTour.Stops.Add(city);
+        if (!ProblemInstance.TourFeasible(newTour, this)) {
+          newTour.Stops.Remove(city);
+          if (newTour.Stops.Count > 0)
+            result.Add(newTour);
+
+          newTour = new Tour();
+          newTour.Stops.Add(city);
+        }
+      }
+
+      if (newTour.Stops.Count > 0)
+        result.Add(newTour);
+
+      //if there are too many vehicles - repair
+      while (result.Count > ProblemInstance.Vehicles.Value) {
+        Tour tour = result[result.Count - 1];
+
+        //find predecessor / successor in permutation
+        int predecessorIndex = Array.IndexOf(this.array, tour.Stops[0] - 1) - 1;
+        if (predecessorIndex >= 0) {
+          int predecessor = this[predecessorIndex] + 1;
+
+          foreach (Tour t in result) {
+            int insertPosition = t.Stops.IndexOf(predecessor) + 1;
+            if (insertPosition != -1) {
+              t.Stops.InsertRange(insertPosition, tour.Stops);
+              break;
+            }
+          }
+        } else {
+          int successorIndex = Array.IndexOf(this.array,
+            tour.Stops[tour.Stops.Count - 1] - 1) + 1;
+          int successor = this[successorIndex] + 1;
+
+          foreach (Tour t in result) {
+            int insertPosition = t.Stops.IndexOf(successor);
+            if (insertPosition != -1) {
+              t.Stops.InsertRange(insertPosition, tour.Stops);
+              break;
+            }
+          }
+        }
+
+        result.Remove(tour);
+      }
+
+      return result;
+    }
+    #endregion
+
+    public ZhuEncodedSolution(Permutation permutation, IVRPProblemInstance problemInstance)
+      : base(permutation, problemInstance) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ZhuEncodedSolution(this, cloner);
+    }
+
+    protected ZhuEncodedSolution(ZhuEncodedSolution original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    [StorableConstructor]
+    protected ZhuEncodedSolution(StorableConstructorFlag _) : base(_) {
+    }
+
+    public static ZhuEncodedSolution ConvertFrom(IVRPEncodedSolution encoding, IVRPProblemInstance problemInstance) {
+      List<Tour> tours = encoding.GetTours();
+      List<int> route = new List<int>();
+
+      foreach (Tour tour in tours) {
+        foreach (int city in tour.Stops)
+          route.Add(city - 1);
+      }
+
+      return new ZhuEncodedSolution(
+        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()), problemInstance);
+    }
+
+    public static ZhuEncodedSolution ConvertFrom(List<int> routeParam, IVRPProblemInstance problemInstance) {
+      List<int> route = new List<int>(routeParam);
+
+      while (route.Remove(0)) { //remove all delimiters (0)
+      }
+
+      for (int i = 0; i < route.Count; i++)
+        route[i]--;
+
+      return new ZhuEncodedSolution(
+        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()), problemInstance);
+    }
+  }
+}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/HeuristicLab.Problems.VehicleRouting-3.4.csproj	(revision 17698)
@@ -135,4 +135,5 @@
     <Compile Include="Analyzer\ConstraintRelaxation\TimeWindowed\TimeWindowRelaxationVRPAnalyzer.cs" />
     <Compile Include="Analyzer\VRPSolution.cs" />
+    <Compile Include="Encodings\Alba\AlbaEncoding.cs" />
     <Compile Include="Encodings\Potvin\Moves\TwoOptStar\IPotvinTwoOptStarMoveOperator.cs" />
     <Compile Include="Encodings\Potvin\Moves\TwoOptStar\PotvinTwoOptStarExhaustiveMoveGenerator.cs" />
@@ -148,4 +149,5 @@
     <Compile Include="Improver\VRPImprovementOperator.cs" />
     <Compile Include="Improver\VRPIntraRouteImprovementOperator.cs" />
+    <Compile Include="Interfaces\IVRPEncoding.cs" />
     <Compile Include="Interfaces\IVRPLocalSearchManipulator.cs" />
     <Compile Include="Interpreters\MDCVRPInterpreter.cs" />
@@ -158,5 +160,5 @@
     <Compile Include="PathRelinkers\VRPPathRelinker.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Encodings\Alba\AlbaEncoding.cs" />
+    <Compile Include="Encodings\Alba\AlbaEncodedSolution.cs" />
     <Compile Include="Encodings\Alba\Creators\RandomCreator.cs" />
     <Compile Include="Encodings\Alba\Creators\AlbaCreator.cs" />
@@ -227,5 +229,5 @@
     <Compile Include="Encodings\General\TourEncoding.cs" />
     <Compile Include="Encodings\GVR\Crossovers\GVRCrossover.cs" />
-    <Compile Include="Encodings\GVR\GVREncoding.cs" />
+    <Compile Include="Encodings\GVR\GVREncodedSolution.cs" />
     <Compile Include="Encodings\GVR\IGVROperator.cs" />
     <Compile Include="Encodings\GVR\Manipulators\GVRDisplacementManipulator.cs" />
@@ -304,5 +306,5 @@
     <Compile Include="Encodings\Potvin\Moves\VehicleAssignment\PotvinVehicleAssignmentMultiMoveGenerator.cs" />
     <Compile Include="Encodings\Potvin\Moves\VehicleAssignment\PotvinVehicleAssignmentSingleMoveGenerator.cs" />
-    <Compile Include="Encodings\Potvin\PotvinEncoding.cs" />
+    <Compile Include="Encodings\Potvin\PotvinEncodedSolution.cs" />
     <Compile Include="Encodings\Prins\Crossovers\PrinsCrossover.cs" />
     <Compile Include="Encodings\Prins\Crossovers\PrinsPermutationCrossover.cs" />
@@ -313,5 +315,5 @@
     <Compile Include="Encodings\Prins\Manipulators\PrinsPermutationManipulator.cs" />
     <Compile Include="Encodings\Prins\Manipulators\PrinsStochasticLSManipulator.cs" />
-    <Compile Include="Encodings\Prins\PrinsEncoding.cs" />
+    <Compile Include="Encodings\Prins\PrinsEncodedSolution.cs" />
     <Compile Include="Encodings\VRPOperator.cs" />
     <Compile Include="Encodings\Zhu\Crossovers\ZhuCrossover.cs" />
@@ -324,5 +326,5 @@
     <Compile Include="Encodings\Zhu\Manipulators\ZhuManipulator.cs" />
     <Compile Include="Encodings\Zhu\Manipulators\ZhuPermutationManipulator.cs" />
-    <Compile Include="Encodings\Zhu\ZhuEncoding.cs" />
+    <Compile Include="Encodings\Zhu\ZhuEncodedSolution.cs" />
     <Compile Include="Interfaces\IMultiVRPOperator.cs" />
     <Compile Include="Interfaces\IVRPManipulator.cs" />
@@ -333,5 +335,5 @@
     <Compile Include="Interfaces\IVRPMultiNeighborhoodShakingOperator.cs" />
     <Compile Include="Interfaces\IVRPOperator.cs" />
-    <Compile Include="Interfaces\IVRPEncoding.cs" />
+    <Compile Include="Interfaces\IVRPEncodedSolution.cs" />
     <Compile Include="Interfaces\IVRPProblemInstance.cs" />
     <Compile Include="Plugin.cs" />
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPImprovementOperator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPImprovementOperator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPImprovementOperator.cs	(revision 17698)
@@ -76,6 +76,6 @@
 
     public override IOperation InstrumentedApply() {
-      var solution = SolutionParameter.ActualValue as IVRPEncoding;
-      var potvinSolution = solution is PotvinEncoding ? solution as PotvinEncoding : PotvinEncoding.ConvertFrom(solution, ProblemInstance);
+      var solution = SolutionParameter.ActualValue as IVRPEncodedSolution;
+      var potvinSolution = solution is PotvinEncodedSolution ? solution as PotvinEncodedSolution : PotvinEncodedSolution.ConvertFrom(solution, ProblemInstance);
 
       if (solution == null)
@@ -90,5 +90,5 @@
     }
 
-    protected abstract int Improve(PotvinEncoding solution);
+    protected abstract int Improve(PotvinEncodedSolution solution);
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPIntraRouteImprovementOperator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPIntraRouteImprovementOperator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Improver/VRPIntraRouteImprovementOperator.cs	(revision 17698)
@@ -42,5 +42,5 @@
     }
 
-    protected override int Improve(PotvinEncoding solution) {
+    protected override int Improve(PotvinEncodedSolution solution) {
       int evaluatedSolutions = 0;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCreator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCreator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCreator.cs	(revision 17698)
@@ -27,5 +27,5 @@
   [StorableType("36C4F904-7B59-4C09-81C4-BC07D9ABC496")]
   public interface IVRPCreator : IVRPOperator, ISolutionCreator {
-    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> VRPToursParameter { get; }
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCrossover.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCrossover.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPCrossover.cs	(revision 17698)
@@ -27,6 +27,6 @@
   [StorableType("FFAE16E2-265C-464E-9903-24154F6B0628")]
   public interface IVRPCrossover : IVRPOperator, ICrossover {
-    ILookupParameter<ItemArray<IVRPEncoding>> ParentsParameter { get; }
-    ILookupParameter<IVRPEncoding> ChildParameter { get; }
+    ILookupParameter<ItemArray<IVRPEncodedSolution>> ParentsParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> ChildParameter { get; }
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncodedSolution.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncodedSolution.cs	(revision 17698)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncodedSolution.cs	(revision 17698)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HEAL.Attic;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
+  [StorableType("A8B95552-3A3D-43B3-95C3-B04602AEACF5")]
+  public interface IVRPEncodedSolution : IItem, IEncodedSolution {
+    List<Tour> GetTours();
+    int GetTourIndex(Tour tour);
+    int GetVehicleAssignment(int tour);
+  }
+}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEncoding.cs	(revision 17698)
@@ -20,14 +20,14 @@
 #endregion
 
-using System.Collections.Generic;
-using HeuristicLab.Core;
 using HEAL.Attic;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
 
-namespace HeuristicLab.Problems.VehicleRouting.Interfaces {
-  [StorableType("A8B95552-3A3D-43B3-95C3-B04602AEACF5")]
-  public interface IVRPEncoding : IItem {
-    List<Tour> GetTours();
-    int GetTourIndex(Tour tour);
-    int GetVehicleAssignment(int tour);
-  }
+namespace HeuristicLab.Problems.VehicleRouting {
+
+  [StorableType("b6674651-cc95-48d8-a2c3-83ee9325def3")]
+  public interface IVRPEncoding : IEncoding { }
+
+  [StorableType("7d010ab3-2e01-4383-bb6c-7c47ef9d803f")]
+  public interface IVRPEncoding<T> : IVRPEncoding, IEncoding<T> where T : class, IVRPEncodedSolution { }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPEvaluator.cs	(revision 17698)
@@ -28,10 +28,10 @@
   [StorableType("C3423687-3CBE-41E4-9227-FF4F1D6912E1")]
   public interface IVRPEvaluator : IVRPOperator, ISingleObjectiveEvaluator {
-    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> VRPToursParameter { get; }
 
-    VRPEvaluation Evaluate(IVRPProblemInstance instance, IVRPEncoding solution);
-    VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour, IVRPEncoding solution);
+    VRPEvaluation Evaluate(IVRPProblemInstance instance, IVRPEncodedSolution solution);
+    VRPEvaluation EvaluateTour(IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution);
     bool Feasible(VRPEvaluation evaluation);
-    double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible);
+    double GetInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, VRPEvaluation eval, int customer, int tour, int index, out bool feasible);
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPManipulator.cs	(revision 17698)
@@ -27,5 +27,5 @@
   [StorableType("AC249F6E-B3A0-49C2-A582-811C132B4DAE")]
   public interface IVRPManipulator : IVRPOperator, IManipulator {
-    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> VRPToursParameter { get; }
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMoveOperator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMoveOperator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMoveOperator.cs	(revision 17698)
@@ -27,5 +27,5 @@
   [StorableType("9425CBF4-8F21-43FC-9AAB-52E263B2BB12")]
   public interface IVRPMoveOperator : IVRPOperator, IMoveOperator {
-    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> VRPToursParameter { get; }
     ILookupParameter VRPMoveParameter { get; }
   }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPMultiNeighborhoodShakingOperator.cs	(revision 17698)
@@ -27,5 +27,5 @@
   [StorableType("48732EFD-AB16-4C96-A720-FB6CAEA0133D")]
   public interface IVRPMultiNeighborhoodShakingOperator : IMultiNeighborhoodShakingOperator, IVRPOperator {
-    ILookupParameter<IVRPEncoding> VRPToursParameter { get; }
+    ILookupParameter<IVRPEncodedSolution> VRPToursParameter { get; }
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interfaces/IVRPProblemInstance.cs	(revision 17698)
@@ -48,12 +48,12 @@
     double[] GetCoordinates(int city);
     double GetDemand(int city);
-    double GetDistance(int start, int end, IVRPEncoding solution);
-    double GetInsertionDistance(int start, int customer, int end, IVRPEncoding solution, out double startDistance, out double endDistance);
-    bool Feasible(IVRPEncoding solution);
-    bool TourFeasible(Tour tour, IVRPEncoding solution);
-    VRPEvaluation Evaluate(IVRPEncoding solution);
-    VRPEvaluation EvaluateTour(Tour tour, IVRPEncoding solution);
+    double GetDistance(int start, int end, IVRPEncodedSolution solution);
+    double GetInsertionDistance(int start, int customer, int end, IVRPEncodedSolution solution, out double startDistance, out double endDistance);
+    bool Feasible(IVRPEncodedSolution solution);
+    bool TourFeasible(Tour tour, IVRPEncodedSolution solution);
+    VRPEvaluation Evaluate(IVRPEncodedSolution solution);
+    VRPEvaluation EvaluateTour(Tour tour, IVRPEncodedSolution solution);
     bool Feasible(VRPEvaluation eval);
-    double GetInsertionCosts(VRPEvaluation eval, IVRPEncoding solution, int customer, int tour, int index, out bool feasible);
+    double GetInsertionCosts(VRPEvaluation eval, IVRPEncodedSolution solution, int customer, int tour, int index, out bool feasible);
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/IVRPDataInterpreter.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/IVRPDataInterpreter.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/IVRPDataInterpreter.cs	(revision 17698)
@@ -29,5 +29,5 @@
     public IVRPProblemInstance ProblemInstance { get; set; }
     public double? BestKnownQuality { get; set; }
-    public IVRPEncoding BestKnownSolution { get; set; }
+    public IVRPEncodedSolution BestKnownSolution { get; set; }
   }
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/VRPInterpreter.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/VRPInterpreter.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Interpreters/VRPInterpreter.cs	(revision 17698)
@@ -29,7 +29,7 @@
     protected abstract void Interpret(IVRPData data, IVRPProblemInstance problemInstance);
 
-    protected virtual IVRPEncoding GetBestKnowTour(IVRPData data, IVRPProblemInstance problemInstance) {
+    protected virtual IVRPEncodedSolution GetBestKnowTour(IVRPData data, IVRPProblemInstance problemInstance) {
       if (data.BestKnownTour != null) {
-        PotvinEncoding solution = new PotvinEncoding(problemInstance);
+        PotvinEncodedSolution solution = new PotvinEncodedSolution(problemInstance);
 
         for (int i = 0; i < data.BestKnownTour.GetLength(0); i++) {
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/PathRelinkers/VRPPathRelinker.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/PathRelinkers/VRPPathRelinker.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/PathRelinkers/VRPPathRelinker.cs	(revision 17698)
@@ -72,5 +72,5 @@
     }
 
-    public static ItemArray<IItem> Apply(PotvinEncoding initiator, PotvinEncoding guide, PercentValue n, int sampleSize, int iterations, IRandom rand, IVRPProblemInstance problemInstance) {
+    public static ItemArray<IItem> Apply(PotvinEncodedSolution initiator, PotvinEncodedSolution guide, PercentValue n, int sampleSize, int iterations, IRandom rand, IVRPProblemInstance problemInstance) {
       if (initiator == null || guide == null)
         throw new ArgumentException("Cannot relink path because one of the provided solutions or both are null.");
@@ -87,8 +87,8 @@
         originalTardinessPenalty.Value = (problemInstance as ITimeWindowedProblemInstance).TardinessPenalty.Value;
 
-      PotvinEncoding current = MatchTours(initiator, guide, problemInstance);
+      PotvinEncodedSolution current = MatchTours(initiator, guide, problemInstance);
       double currentSimilarity = VRPSimilarityCalculator.CalculateSimilarity(current, guide);
 
-      IList<PotvinEncoding> solutions = new List<PotvinEncoding>();
+      IList<PotvinEncodedSolution> solutions = new List<PotvinEncodedSolution>();
       int i = 0;
       while (i < iterations && !currentSimilarity.IsAlmost(1.0)) {
@@ -98,5 +98,5 @@
         if (currentSimilarity < 1.0) {
           for (int sample = 0; sample < sampleSize; sample++) {
-            var next = current.Clone() as PotvinEncoding;
+            var next = current.Clone() as PotvinEncodedSolution;
 
             int neighborhood = rand.Next(3);
@@ -159,5 +159,5 @@
     }
 
-    private static IList<IItem> ChooseSelection(IList<PotvinEncoding> solutions, PercentValue n) {
+    private static IList<IItem> ChooseSelection(IList<PotvinEncodedSolution> solutions, PercentValue n) {
       IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
@@ -176,10 +176,10 @@
         throw new ArgumentException("The number of parents is not equal to 2.");
 
-      if (!(parents[0] is PotvinEncoding))
-        parents[0] = PotvinEncoding.ConvertFrom(parents[0] as IVRPEncoding, ProblemInstanceParameter.ActualValue);
-      if (!(parents[1] is PotvinEncoding))
-        parents[1] = PotvinEncoding.ConvertFrom(parents[1] as IVRPEncoding, ProblemInstanceParameter.ActualValue);
-
-      return Apply(parents[0] as PotvinEncoding, parents[1] as PotvinEncoding, n,
+      if (!(parents[0] is PotvinEncodedSolution))
+        parents[0] = PotvinEncodedSolution.ConvertFrom(parents[0] as IVRPEncodedSolution, ProblemInstanceParameter.ActualValue);
+      if (!(parents[1] is PotvinEncodedSolution))
+        parents[1] = PotvinEncodedSolution.ConvertFrom(parents[1] as IVRPEncodedSolution, ProblemInstanceParameter.ActualValue);
+
+      return Apply(parents[0] as PotvinEncodedSolution, parents[1] as PotvinEncodedSolution, n,
         SampleSizeParameter.Value.Value, IterationsParameter.Value.Value, RandomParameter.ActualValue, ProblemInstanceParameter.ActualValue);
     }
@@ -189,6 +189,6 @@
     }
 
-    private static PotvinEncoding MatchTours(PotvinEncoding initiator, PotvinEncoding guide, IVRPProblemInstance problemInstance) {
-      var result = new PotvinEncoding(problemInstance);
+    private static PotvinEncodedSolution MatchTours(PotvinEncodedSolution initiator, PotvinEncodedSolution guide, IVRPProblemInstance problemInstance) {
+      var result = new PotvinEncodedSolution(problemInstance);
 
       var used = new List<bool>();
@@ -226,13 +226,13 @@
 
     #region moves
-    public static PotvinEncoding RouteBasedXOver(PotvinEncoding initiator, PotvinEncoding guide, IRandom random, IVRPProblemInstance problemInstance) {
+    public static PotvinEncodedSolution RouteBasedXOver(PotvinEncodedSolution initiator, PotvinEncodedSolution guide, IRandom random, IVRPProblemInstance problemInstance) {
       return PotvinRouteBasedCrossover.Apply(random, initiator, guide, problemInstance, false);
     }
 
-    public static PotvinEncoding SequenceBasedXOver(PotvinEncoding initiator, PotvinEncoding guide, IRandom random, IVRPProblemInstance problemInstance) {
+    public static PotvinEncodedSolution SequenceBasedXOver(PotvinEncodedSolution initiator, PotvinEncodedSolution guide, IRandom random, IVRPProblemInstance problemInstance) {
       return PotvinSequenceBasedCrossover.Apply(random, initiator, guide, problemInstance, false);
     }
 
-    public static void GuidedRelocateMove(PotvinEncoding initiator, PotvinEncoding guide, IRandom random) {
+    public static void GuidedRelocateMove(PotvinEncodedSolution initiator, PotvinEncodedSolution guide, IRandom random) {
       List<int> cities = new List<int>();
       foreach (Tour tour in initiator.Tours) {
@@ -291,5 +291,5 @@
     }
 
-    public static void RelocateMove(PotvinEncoding individual, IRandom random) {
+    public static void RelocateMove(PotvinEncodedSolution individual, IRandom random) {
       int cities = individual.Cities;
       int city = 1 + random.Next(cities);
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPEvaluator.cs	(revision 17698)
@@ -40,5 +40,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -96,5 +96,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPInsertionInfo;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPPDTW/MDCVRPPDTWEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPPDTW/MDCVRPPDTWEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/MultiDepotVRP/MDCVRP/MDCVRPTW/MDCVRPPDTW/MDCVRPPDTWEvaluator.cs	(revision 17698)
@@ -42,5 +42,5 @@
     }
 
-    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncoding solution) {
+    protected override void EvaluateTour(VRPEvaluation eval, IVRPProblemInstance instance, Tour tour, IVRPEncodedSolution solution) {
       TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
       eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
@@ -182,5 +182,5 @@
     }
 
-    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncoding solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+    protected override double GetTourInsertionCosts(IVRPProblemInstance instance, IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
       out bool feasible) {
       CVRPPDTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPPDTWInsertionInfo;
